<?php

declare(strict_types=1);

namespace A2G\A2gProducts\Domain\Model;


/**
 * This file is part of the "altogether Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * FilterOptions
 */
class FilterOptions extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * title
     *
     * @var string
     */
    protected $title = '';

    /**
     * valueMin
     *
     * @var float
     */
    protected $valueMin = 0.0;

    /**
     * valueMax
     *
     * @var float
     */
    protected $valueMax = 0.0;

    /**
     * Returns the title
     *
     * @return string $title
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Sets the title
     *
     * @param string $title
     * @return void
     */
    public function setTitle(string $title)
    {
        $this->title = $title;
    }

    /**
     * Returns the valueMin
     *
     * @return float $valueMin
     */
    public function getValueMin()
    {
        return $this->valueMin;
    }

    /**
     * Sets the valueMin
     *
     * @param float $valueMin
     * @return void
     */
    public function setValueMin(float $valueMin)
    {
        $this->valueMin = $valueMin;
    }

    /**
     * Returns the valueMax
     *
     * @return float $valueMax
     */
    public function getValueMax()
    {
        return $this->valueMax;
    }

    /**
     * Sets the valueMax
     *
     * @param float $valueMax
     * @return void
     */
    public function setValueMax(float $valueMax)
    {
        $this->valueMax = $valueMax;
    }
    
    /**
     * Getter for _localizedUid.
     *
     * @return int|null The _localizedUid or NULL if none set yet.
     */
    public function getLocalizedUid(): ?int
    {
        if ($this->_localizedUid !== null) {
            return (int)$this->_localizedUid;
        }
        return null;
    }

}
