<?php

declare(strict_types=1);

namespace A2G\A2gProducts\Domain\Model;

use A2G\A2gProducts\Domain\Model\Ingredients;
use TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy;

/**
 * This file is part of the "Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * MasonryItem
 */
class MasonryItem extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

    /**
     * header
     *
     * @var string
     */
    protected $header = '';

    /**
     * itemClass
     *
     * @var string
     */
    protected $itemClass = '';

    /**
     * image
     *
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $image = null;

    public function getHeader(): string {
        return $this->header;
    }

    public function getItemClass(): string {
        return $this->itemClass;
    }

    public function getImage(): \TYPO3\CMS\Extbase\Domain\Model\FileReference {
        if ($this->image instanceof LazyLoadingProxy) {
            $this->image = $this->image->_loadRealInstance();
        }
        return $this->image;
    }

    public function setHeader(string $header): void {
        $this->header = $header;
    }

    public function setItemClass(string $itemClass): void {
        $this->itemClass = $itemClass;
    }

    public function setImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $image): void {
        $this->image = $image;
    }

        
    /**
     * __construct
     */
    public function __construct() {

        // Do not remove the next line: It would break the functionality
        $this->initializeObject();
    }

    /**
     * Initializes all ObjectStorage properties when model is reconstructed from DB (where __construct is not called)
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    public function initializeObject() {
        $this->relCategory = $this->relCategory ?: new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->relFilterValues = $this->relFilterValues ?: new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

}
