<?php

declare(strict_types=1);

namespace A2G\A2gProducts\Domain\Model;

use A2G\A2gProducts\Domain\Model\{
    Ingredients,
ProductVariants
    
};
use TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy;

/**
 * This file is part of the "Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * ProductVariants
 */
class ProductVariantSizes extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

    /**
     * nr
     *
     * @var string
     * @TYPO3\CMS\Extbase\Annotation\Validate("NotEmpty")
     */
    protected $nr = '';

    /**
     * title
     *
     * @var string
     */
    protected $title = '';

    /**
     * pathSegment
     * 
     * @var string
     */
    protected $pathSegment = '';
    
    /**
     * description
     *
     * @var string
     */
    protected $description = '';

    /**
     * @var ProductVariants
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $productvariant = null;

    /**
     * 
     * @return ProductVariants
     */
    public function getProductvariant(): ProductVariants {
         if ($this->productvariant instanceof LazyLoadingProxy) {
            $this->productvariant = $this->productvariant->_loadRealInstance();
        }
        return $this->productvariant;
    }

    /**
     * 
     * @param ProductVariants $productvariant
     * @return void
     */
    public function setProductvariant(ProductVariants $productvariant): void {
        $this->productvariant = $productvariant;
    }

    
    /**
     * Returns the nr
     *
     * @return string $nr
     */
    public function getNr() {
        return $this->nr;
    }

    /**
     * Sets the nr
     *
     * @param string $nr
     * @return void
     */
    public function setNr(string $nr) {
        $this->nr = $nr;
    }

    /**
     * Returns the title
     *
     * @return string $title
     */
    public function getTitle() {
        return $this->title;
    }

    /**
     * Sets the title
     *
     * @param string $title
     * @return void
     */
    public function setTitle(string $title) {
        $this->title = $title;
    }

    /**
     * Returns the pathSegment
     * 
     * @return string $pathSegment
     */
    public function getPathSegment()
    {
        return $this->pathSegment;
    }

    /**
     * Sets the pathSegment
     * 
     * @param string $pathSegment
     * @return void
     */
    public function setPathSegment($pathSegment)
    {
        $this->pathSegment = $pathSegment;
    }
    
    /**
     * Returns the description
     *
     * @return string $description
     */
    public function getDescription() {
        return $this->description;
    }

    /**
     * Sets the description
     *
     * @param string $description
     * @return void
     */
    public function setDescription(string $description) {
        $this->description = $description;
    }
    
    /**
     * __construct
     */
    public function __construct() {
        $this->initializeObject();
    }

    /**
     * Initializes all ObjectStorage properties when model is reconstructed from DB (where __construct is not called)
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    public function initializeObject() {
    }

}
