<?php

declare(strict_types=1);

namespace A2G\A2gProducts\Domain\Model;

/**
 * This file is part of the "altogether Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * SelectableAttribute
 */
class SelectableAttribute extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

    /**
     * relFilterOptions
     *
     * @var \A2G\A2gProducts\Domain\Model\FilterOptions
     */
    protected $relFilterOption = null;

    /**
     * relFilters
     *
     * @var \A2G\A2gProducts\Domain\Model\Filters
     */
    protected $relFilters = null;
    
    /**
     * 
     * @var string
     */
    protected $title = '';

    /**
     * Returns the relFilterOption
     *
     * @return \A2G\A2gProducts\Domain\Model\FilterOptions $relFilterOption
     */
    public function getRelFilterOption() {
        return $this->relFilterOption;
    }

    /**
     * Sets the relFilterOption
     *
     * @param \A2G\A2gProducts\Domain\Model\FilterOptions $relFilterOptio
     * @return void
     */
    public function setRelFilterOption(\A2G\A2gProducts\Domain\Model\FilterOptions $relFilterOptions) {
        $this->relFilterOption = $relFilterOption;
    }

    /**
     * Returns the relFilters
     *
     * @return \A2G\A2gProducts\Domain\Model\Filters $relFilters
     */
    public function getRelFilters() {
        return $this->relFilters;
    }

    /**
     * Sets the relFilters
     *
     * @param \A2G\A2gProducts\Domain\Model\Filters $relFilters
     * @return void
     */
    public function setRelFilters(\A2G\A2gProducts\Domain\Model\Filters $relFilters) {
        $this->relFilters = $relFilters;
    }
    
    public function getTitle(): string {
        return $this->title;
    }

    public function setTitle(string $title): void {
        $this->title = $title;
    }

}
