<?php

declare(strict_types=1);

namespace A2G\A2gProducts\Domain\Repository;

/* * *
 *
 * This file is part of the "WebX GS Map" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2019 Raphael Martin <raphael@web-crossing.com>, web-crossing gmbh
 *
 * * */

/**
 * The repository for Categories
 */
class CategoriesRepository extends \TYPO3\CMS\Extbase\Persistence\Repository {

    /**
     * @var array
     */
    protected $defaultOrderings = [
        'sorting' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING
    ];

    /**
     * @param array $uids
     */
    public function findByUids(array $uids = []) {
        if (!empty($uids)) {
            $query = $this->createQuery();
            $constraints = [];
            $constraints[] = $query->in('uid', $uids);
            $query->matching($query->logicalAnd($constraints));
            return $query->execute();
        }
    }

}
