<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace A2G\A2gProducts\Services;

/**
 * Description of FeuserSessionService
 *
 * @author Raphael Martin
 */
class FeuserSessionService {

    /**
     * keyPrefix
     * 
     * @var string
     */
    protected $keyPrefix = '';

    /**
     * 
     * @param string $keyPrefix
     */
    public function __construct(string $keyPrefix = '') {
        $this->keyPrefix = $keyPrefix;
    }

    /**
     * Returns the object stored in the user´s PHP session
     * @param string $key
     * @return type the stored object
     */
    public function get(string $key) {
        $sessionData = $GLOBALS['TSFE']->fe_user->getKey('ses', $this->keyPrefix . $key);
        return unserialize($sessionData);
    }

    /**
     * Writes an object into the PHP session
     * 
     * @param type $object any serializable object to store into the session
     * @param string $key identifier from the store in the session
     * @return FeuserSessionService
     */
    public function set($object, string $key): FeuserSessionService {
        $sessionData = serialize($object);
        $GLOBALS['TSFE']->fe_user->setKey('ses', $this->keyPrefix . $key, $sessionData);
        $GLOBALS['TSFE']->fe_user->storeSessionData();
        return $this;
    }

    /**
     * Cleans up the session: removes the stored object from the PHP session
     * 
     * @param type $key identifier from the store in the session to clean
     * @return FeuserSessionService
     */
    public function clean($key): FeuserSessionService {
        $GLOBALS['TSFE']->fe_user->setKey('ses', $this->keyPrefix . $key, NULL);
        $GLOBALS['TSFE']->fe_user->storeSessionData();
        return $this;
    }

    /**
     * set a prefix for your session store keys
     * 
     * @param string $prefixKey
     * @return void
     */
    public function setKeyPrefix(string $keyPrefix = ''): void {
        $this->keyPrefix = $keyPrefix;
    }

}
