<?php

declare(strict_types=1);

namespace A2G\A2gProducts\User;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Database\ConnectionPool;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of FilterValuesMatcher
 *
 * @author Raphael Martin
 */
class FilterValuesMatcher {

    protected $conRegistration;

    /**
     * 
     */
    public function __construct() {
        $conPool = GeneralUtility::makeInstance(ConnectionPool::class);
        $this->conRegistration = $conPool->getConnectionForTable('tx_a2gproducts_domain_model_filtervalues');
    }

    /**
     * @param type $parameters
     * @param type $parentObject
     * @return bool
     */
    public function showOptionsSelect(&$parameters, $parentObject): bool {
        try {
            $sql = 'SELECT count(foT.uid) as count '
                    . 'FROM tx_a2gproducts_domain_model_filteroptions AS foT '
                    . 'JOIN tx_a2gproducts_domain_model_filters AS fT ON fT.uid = foT.filters '
                    . 'WHERE fT.uid = ? AND fT.filter_type=3 AND foT.hidden = 0 AND foT.deleted=0';
            $stmt = $this->conRegistration->prepare($sql);
            $stmt->bindValue(1, (int) $parameters['record']['rel_filters'][0]);
            $stmt->execute();
            $tmp = $stmt->fetchAll();
            if ($tmp[0] !== null) {
                return (bool) $tmp[0]['count'];
            } else {
                return false;
            }
        } catch (\Exception $e) {
            return false;
        }
    }

    /**
     * 
     * @param type $parameters
     * @param type $parentObject
     * @return bool
     */
    public function showValueInput(&$parameters, $parentObject): bool {

        try {
            $sql = 'SELECT count(foT.uid) as count '
                    . 'FROM tx_a2gproducts_domain_model_filteroptions AS foT '
                    . 'JOIN tx_a2gproducts_domain_model_filters AS fT ON fT.uid = foT.filters '
                    . 'WHERE fT.uid = ? AND fT.filter_type IN ( 1,2 ) AND foT.hidden = 0 AND foT.deleted=0 AND foT.sys_language_uid = 0';
            $stmt = $this->conRegistration->prepare($sql);
            $stmt->bindValue(1, (int) $parameters['record']['rel_filters'][0]);
            $stmt->execute();
            $tmp = $stmt->fetchAll();
            if ($tmp[0] !== null) {
                return (bool) $tmp[0]['count'];
            } else {
                return false;
            }
        } catch (\Exception $e) {
            return false;
        }
    }

    /**
     * 
     * @param type $parameters
     * @param type $parentObject
     * @return void
     */
    public function title(&$parameters, $parentObject):void {
        try {
            if(array_key_exists('rel_filters', $parameters['row']){
            if(array_key_exists(0,$parameters['row']['rel_filters'])){
                $sql2 = 'SELECT fT.title AS title '
                    . 'FROM tx_a2gproducts_domain_model_filters AS fT '
                    . ' WHERE fT.uid = ? AND fT.deleted = 0 AND fT.hidden = 0';
                $stmt2 = $this->conRegistration->prepare($sql2);
                $stmt2->bindValue(1, (int) $parameters['row']['rel_filters'][0]);
                $stmt2->execute();
                $tmp2 = $stmt2->fetchAll();
                if (array_key_exists(0, $tmp2)) {
                    $out = $tmp2[0]['title'];
                }  else {
                    $out = '';
                }
                $sql = 'SELECT fT.title AS title '
                        . 'FROM tx_a2gproducts_domain_model_filteroptions AS fT '
                        . ' WHERE fT.uid = ? AND fT.deleted = 0 AND fT.hidden = 0';
                $stmt = $this->conRegistration->prepare($sql);
                $stmt->bindValue(1, (int) $parameters['row']['rel_filter_option'][0]);
                $stmt->execute();
                $tmp = $stmt->fetchAll();
                if (array_key_exists(0, $tmp)) {
                    $out .= ': ' . $tmp[0]['title'];
                } else {
                    $out .= ': ' . $parameters['row']['value'];
                }
                $parameters['title'] .= $out;
            }
        }
        } catch (\Exception $e) {
            
        }
    }

}
