/* 
 * Copyright (C) 2021 Raphael Martin <r.martin@felder-group.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * GaCheckout
 */
var GaCheckout = function () {
    'use strict';
    var Constructor = function () {
    };
    Constructor.prototype.checkout = function (step, option, GaProductsObject, url) {
        if (typeof ga === 'function' && typeof dataLayer === 'object' && typeof GaProductsObject === 'object' && GaProductsObject instanceof GaProducts) {
            var products = [];
            for (var i = 0; i < GaProductsObject.arr.length; i++) {
                products.push({
                    'name': GaProductsObject.arr[i].name, // Name or ID is required.
                    'id': GaProductsObject.arr[i].id,
                    'price': GaProductsObject.arr[i].price,
                    'brand': GaProductsObject.arr[i].brand,
                    'category': GaProductsObject.arr[i].category,
                    'variant': GaProductsObject.arr[i].variant,
                    'quantity': GaProductsObject.arr[i].quantity
                });
            }
            dataLayer.push({
                'event': 'checkout',
                'ecommerce': {
                    'checkout': {
                        'actionField': {'step': step, 'option': option},
                        'products': products
                    }
                },
                'eventCallback': function(){
                    document.location = url;
                }
            });
        } else {
            console.log('GaCheckout.checkout requiers ga and dataLayer');
        }
    };
    Constructor.prototype.checkoutOption = function (step, option) {
        if (typeof ga === 'function' && typeof dataLayer === 'object') {
            dataLayer.push({
                'event': 'checkoutOption',
                'ecommerce': {
                    'checkout': {
                        'actionField': {'step': step, 'option': option}
                    }
                }
            });
        } else {
//            console.log('checkoutOption requiers ga and dataLayer');
        }
    };
    return Constructor;
}();


