/* 
 * Copyright (C) 2021 Raphael Martin <r.martin@felder-group.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * GaProduct
 */
var GaProduct = function () {
    'use strict';
    var Constructor = function (id, name, price = 0.0, quantity = 0, currency = '', categories = [], listId = 'all_products', listName = 'All Products', position = 0, brand = '', variant = '', locationId = '', affiliation = 'altogether store', discount = 0.0, coupon = '') {
        if (typeof ga === 'function' && typeof dataLayer === 'object' && typeof gtag === 'function') {
            this.item_id = id;
            this.item_name = name;
            for (var i = 0; i < categories.length; i++) {
                if (i === 0) {
                    this.item_category = categories[i];
                }
                if (i === 1) {
                    this.item_category2 = categories[i];
                }
                if (i === 2) {
                    this.item_category3 = categories[i];
                }
                if (i === 3) {
                    this.item_category4 = categories[i];
                }
                if (i === 4) {
                    this.item_category5 = categories[i];
                }
            }
            if (price > 0) {
                this.price = price;
            }
            if (currency !== '') {
                this.currency = currency;
            }
            if (quantity > 0) {
                this.quantity = quantity;
            }
            if (position > 0) {
                this.index = position;
            }
            if (brand !== '') {
                this.item_brand = brand;
            }
            if (variant !== '') {
                this.item_variant = variant;
            }
            if (listId !== '') {
                this.item_list_id = listId;
            }
            if (listName !== '') {
                this.item_list_name = listName;
            }
            if (locationId !== '') {
                this.location_id = locationId;
            }
            if (affiliation !== '') {
                this.affiliation = affiliation;
            }
            if (discount > 0.00) {
                this.discount = discount;
            }
            if (coupon !== '') {
                this.coupon = coupon;
            }
        } else {
            console.log('ga datalayer or gtag missing');
    }
    };
    Constructor.prototype.selectItem = function () {
        gtag('event', 'select_item', {
            item_list_id: this.listId,
            item_list_name: this.listName,
            items: [JSON.stringify(this)]
        });
    };
    Constructor.prototype.viewItem = function () {
        gtag('event', 'view_item', {
            currency: this.currency,
            value: this.price,
            items: [JSON.stringify(this)]
        });
    };
    Constructor.prototype.addToCart = function (currencyCode = 'EUR') {
        if (typeof ga === 'function' && typeof dataLayer === 'object') {
            dataLayer.push({
                'event': 'addToCart',
                'ecommerce': {
                    'currencyCode': currencyCode.toUpperCase(),
                    'add': {
                        'products': [{
                                'name': this.name, // Name or ID is required.
                                'id': this.id,
                                'price': this.price,
                                'brand': this.brand,
                                'category': this.category,
                                'variant': this.variant,
                                'position': this.position
                            }]
                    }
                }
            });
        } else {
//            console.log('GaProduct.addToCart requiers ga and dataLayer');
    }
    };
    Constructor.prototype.removeFromCart = function () {
        if (typeof ga === 'function' && typeof dataLayer === 'object') {
            dataLayer.push({
                'event': 'removeFromCart',
                'ecommerce': {
                    'remove': {
                        'products': [{
                                'name': this.name, // Name or ID is required.
                                'id': this.id,
                                'price': this.price,
                                'brand': this.brand,
                                'category': this.category,
                                'variant': this.variant,
                                'position': this.position
                            }]
                    }
                }
            });
        } else {
//            console.log('GaProduct.removeFromCart requiers ga and dataLayer');
        }
    };
    return Constructor;
}();
