/* 
 * Copyright (C) 2021 Raphael Martin <r.martin@felder-group.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * GaPromotion
 */
var GaPromotion = function () {
    'use strict';
    var Constructor = function (id, name, creative, position) {
        this.id = id;
        this.name = name;
        this.creative = creative;
        this.position = position;
    };
    Constructor.prototype.promotionClick = function (url) {
        if (typeof ga === 'function' && typeof dataLayer === 'object') {
            var promotions = [];
            promotions.push({
                'id': this.id, // Name or ID is required.
                'name': this.name,
                'creative': this.creative,
                'position': this.position
            });
            dataLayer.push({
                'event': 'promotionClick',
                'ecommerce': {
                    'promoClick': {
                        'promotions': promotions
                    }
                },
                'eventCallback': function(){
                    document.location = url;
                }
            });
        } else {
//            console.log('GaPromotion.promotionClick requiers ga and dataLayer');
        }
    };
    return Constructor;
}();
