/* 
 * Copyright (C) 2021 Raphael Martin <r.martin@felder-group.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * GaPromotions
 */
var GaPromotions = function () {
    'use strict';
    var Constructor = function (GaPromotionObject) {
        this.arr = [];
        if (typeof (GaPromotionObject) === 'object' && GaPromotionObject instanceof GaPromotion) {
            this.arr.push(GaPromotionObject);
        } else {
            console.log('GaPromotionObject must be a instanceof GaPromotion');
        }
    };
    Constructor.prototype.push = function (GaProductObject) {
        if (typeof (GaProductObject) === 'object' && GaProductObject instanceof GaProduct) {
            this.arr.push(GaProductObject);
        } else {
            console.log('GaProductObject must be a instanceof GaProduct');
        }
    };
    Constructor.prototype.promoView = function () {
        if (typeof ga === 'function' && typeof dataLayer === 'object' && this.arr.length > 0) {
            var promotions = [];
            for (var i = 0; i < this.arr.length; i++) {
                promotions.push({
                    'id': this.arr[i].id, // Name or ID is required.
                    'name': this.arr[i].name,
                    'creative': this.arr[i].creative,
                    'position': this.arr[i].position
                });
            }
            dataLayer.push({
                'ecommerce': {
                    'promoView': {
                        'promotions': promotions
                    }
                }
            });
        } else {
//            console.log('GaPromotions.promoView requiers ga and dataLayer');
        }
    };
    return Constructor;
}(GaPromotion);
