/* 
 * Copyright (C) 2021 Raphael Martin <r.martin@felder-group.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * GaPurchase
 */
var GaPurchase = function () {
    'use strict';
    var Constructor = function (id, affiliation, revenue, tax, shipping, coupon) {
        this.id = id;
        this.affiliation = affiliation;
        this.revenue = revenue;
        this.tax = tax;
        this.shipping = shipping;
        this.coupon = coupon;
    };
    Constructor.prototype.purchase = function (GaProductsObject) {
        if (typeof ga === 'function' && typeof dataLayer === 'object' && typeof GaProductsObject === 'object' && GaProductsObject instanceof GaProducts) {
            var products = [];
            for (var i = 0; i < GaProductsObject.arr.length; i++) {
                products.push({
                    'name': GaProductsObject.arr[i].name, // Name or ID is required.
                    'id': GaProductsObject.arr[i].id,
                    'price': GaProductsObject.arr[i].price,
                    'brand': GaProductsObject.arr[i].brand,
                    'category': GaProductsObject.arr[i].category,
                    'variant': GaProductsObject.arr[i].variant,
                    'quantity': GaProductsObject.arr[i].quantity
                });
            }
            dataLayer.push({
                'event': 'checkout',
                'ecommerce': {
                    'purchase': {
                        'actionField': {
                            'id': this.id, // Transaction ID. Required for purchases and refunds.
                            'affiliation': this.affiliation,
                            'revenue': this.revenue, // Total transaction value (incl. tax and shipping)
                            'tax': this.tax,
                            'shipping': this.shipping,
                            'coupon': this.coupon
                        },
                        'products': products
                    }
                }
            });
        } else {
//            console.log('GaPurchase.purchase requiers ga and dataLayer');
        }
    };
    return Constructor;
}(GaProducts);