/* 
 * Copyright (C) 2021 Raphael Martin <r.martin@felder-group.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * GaRefunds
 */
var GaRefunds = function () {
    'use strict';
    var Constructor = function (gaRefundObject) {
        
        if (typeof (gaRefundObject) === 'object' && gaRefundObject instanceof GaRefund) {
            this.gaRefund = gaRefundObject;
        } else {
            console.log('GaProductObject must be a instanceof GaProduct');
        }
    };
    Constructor.prototype.refund = function (GaProductsObject) {
        if (typeof ga === 'function' && typeof dataLayer === 'object' && typeof GaProductsObject === 'object' && GaProductsObject instanceof GaProducts) {
            var products = [];
            for (var i = 0; i < GaProductsObject.arr.length; i++) {
                products.push({
                    'id': GaProductsObject.arr[i].id,
                    'quantity': GaProductsObject.arr[i].quantity
                });
            }
            dataLayer.push({
                'event': 'checkout',
                'ecommerce': {
                    'refund': {
                        'actionField': {
                            'id': this.gaRefund.id
                        },
                        'products': products
                    }
                }
            });
        } else {
//            console.log('GaRefunds.refund requiers ga and dataLayer');
        }
    };
    return Constructor;
}(GaProducts, GaRefund);