if (window.Element && !Element.prototype.closest) {
    Element.prototype.closest =
            function (s) {
                var matches = (this.document || this.ownerDocument).querySelectorAll(s), i, el = this;
                do {
                    i = matches.length;
                    while (--i >= 0 && matches.item(i) !== el) {
                    }
                    ;
                } while ((i < 0) && (el = el.parentElement));
                return el;
            };
}

var a2gProductsList = {
    wrapClass: 'altogether-products',
    filterInputClass: 'a2g-filter-input',
    ajaxFormClass: 'a2g-ajax-form',
    ajaxContentClass: 'a2g-ajax-content',
    ajaxLoadMoreInputClass: 'a2g-ajax-loads',
    ajaxLoadMoreBtnClass: 'a2g-ajax-loadmore-btn',
    ajaxLoadMoreBtnWrapClass: 'a2g-ajax-loadmore-btn-wrap',
    ajaxSpinnerClass: 'a2g-ajax-spinner',
    ajaxLoadingSpinner: '<div class="a2g-ajax-spinner w-100 d-flex"><div class="spinner-border m-auto" style="width: 4rem; height: 4rem;" role="status"><span class="sr-only"></span></div></div>',
    checkIfFilterIsFilledOnInit: function () {
        
    },
    initFormSubmit: function (_this, ajaxForms, i) {
        ajaxForms[i].querySelector('.' + _this.ajaxFormClass).addEventListener("submit", function (e) {
            e.preventDefault();
            _this.formSubmitAction(_this, this);
            return false;
        });
    },
    formSubmitAction: function(_this, activeForm){
            var activeContent = activeForm.closest('.' + _this.wrapClass).querySelector('.' + _this.ajaxContentClass);
            activeContent.innerHTML = _this.ajaxLoadingSpinner;
            activeForm.querySelector('.' + _this.ajaxLoadMoreInputClass).value = 0;
            jQuery.ajax({
                async: 'true',
                url: $(activeForm).attr('action'),
                type: 'POST',
                data: $(activeForm).serializeArray(),
                dataType: 'html',
                success: function (result) {
                    activeForm.closest('.' + _this.wrapClass).querySelector('.' + _this.ajaxContentClass).innerHTML = result;
                    _this.initLoadMore(_this, activeContent.querySelector('.' + _this.ajaxLoadMoreBtnClass));
                    if (typeof (a2gShop) === 'object') {
                        a2gShop.cart.setCartActions(a2gShop.cart, activeContent.getElementsByClassName(a2gShop.cart.productWrapClass));
                    }
                },
                error: function (error) {
                    // console.log(error);
                },
                done: function () {
                }
            });
    },
    initLoadMore: function (_this, btn) {
        if (btn !== null) {
            
            btn.addEventListener("click", function () {
                var activeForm = this.closest('.' + _this.wrapClass).querySelector('.' + _this.ajaxFormClass),
                activeContent = this.closest('.' + _this.wrapClass).querySelector('.' + _this.ajaxContentClass);
                activeContent.innerHTML += _this.ajaxLoadingSpinner;
                activeContent.removeChild(activeContent.querySelector('.' + _this.ajaxLoadMoreBtnWrapClass));
                activeForm.querySelector('.' + _this.ajaxLoadMoreInputClass).value = parseInt(activeForm.querySelector('.' + _this.ajaxLoadMoreInputClass).value) + 1;
                jQuery.ajax({
                    async: 'true',
                    url: $(activeForm).attr('action'),
                    type: 'POST',
                    data: $(activeForm).serializeArray(),
                    dataType: 'html',
                    success: function (result) {
                        activeContent.removeChild(activeContent.querySelector('.' + _this.ajaxSpinnerClass));
                        activeContent.innerHTML += result;
                        _this.initLoadMore(_this, activeContent.querySelector('.' + _this.ajaxLoadMoreBtnClass));
                        if (typeof (a2gShop) === 'object') {
                            a2gShop.cart.setCartActions(a2gShop.cart, activeContent.getElementsByClassName(a2gShop.cart.productWrapClass));
                        }
                    },
                    error: function (error) {
                        // console.log(error);
                    },
                    done: function () {
                    }
                });
            });
        }
    },
    init: function () {
        var _this = this, ajaxForms = document.getElementsByClassName(_this.wrapClass), inputs = [];
        document.addEventListener('DOMContentLoaded', function () {
            for (var i = 0; i < ajaxForms.length; i++) {
                inputs[i] = ajaxForms[i].getElementsByClassName(_this.filterInputClass);
                for (var j = 0; j < inputs[i]; j++){
                    inputs[i].checked = false;
                }
                if (ajaxForms[i].querySelector('.' + _this.ajaxFormClass) !== null) {
                    _this.initFormSubmit(_this, ajaxForms, i);
                    _this.initLoadMore(_this, ajaxForms[i].querySelector('.' + _this.ajaxLoadMoreBtnClass));
                }
            }
        });
    }
};
a2gProductsList.init();

var a2gUri = {
    encode: function(uri){
        return encodeURIComponent(uri);
    },
    mailto: function(mailto, subject, body){
        var _this = a2gUri;
        if(typeof(mailto) === 'string' && typeof(subject) === 'string' && typeof(body) === 'string'){
            return 'mailto:'+mailto+'?subject='+_this.encode(subject)+'&body='+_this.encode(body);
        } else if(typeof(mailto) === 'string' && typeof(subject) === 'string'){
            return 'mailto:'+_this.encode(mailto)+'?subject='+_this.encode(subject);
        } else if(typeof(mailto) === 'string'){
            return 'mailto:'+mailto;
        }
    }
};

var a2gProductsDetail = {
    class: {
        wrap: 'a2g-product-detail',
        variant: {
            tab: 'a2g-product-variant-tab'
        },
        request: {
            mail: 'a2g-product-request-mail' 
        }
    },
    setRequestBtnLink: function(subject, body) {
        var _this = a2gProductsDetail;
        var btns = document.getElementsByClassName(_this.class.request.mail);
        for( var i = 0; i < btns.length; i++){
            btns[i].setAttribute('href', a2gUri.mailto(btns[i].dataset.mailto, subject, body));
        }
    },
    getVariantTabTriggerElement: function() {
        var _this = a2gProductsDetail, triggerEle = document.querySelector('.'+_this.class.variant.tab+'[data-href="' + window.location.href + '"]');
        if (triggerEle === null) {
            triggerEle = document.querySelector('.'+_this.class.variant.tab+'[data-href="' + window.location.pathname + '"]');
        }
        return triggerEle;
    },
    fromHistoryBack: false,
    init: function(){
        var _this = a2gProductsDetail;
        if (document.getElementsByClassName(_this.class.wrap)[0] !== null) {
            var tabEl = document.getElementsByClassName(_this.class.variant.tab);
            for (var i = 0; i < tabEl.length; i++) {
                tabEl[i].addEventListener('shown.bs.tab', function (event) {
                    if (!_this.fromHistoryBack) {
                        history.pushState({
                            id: 'homepage-article'
                        }, 'altogether product detail', this.dataset.href);
                    }
                    _this.fromHistoryBack = false;
                    _this.setRequestBtnLink(this.dataset.subject, this.dataset.href);
                });
            }
            window.addEventListener('popstate', function (event) {
                var triggerEle = a2gProductsDetail.getVariantTabTriggerElement();
                if (triggerEle !== null) {
                    _this.fromHistoryBack = true;
                    triggerEle.click();
                }
            });
            var triggerEle = a2gProductsDetail.getVariantTabTriggerElement();
            if (triggerEle !== null) {
                if (!triggerEle.classList.contains('active')) {
                    triggerEle.click();
                }
            }
        }
    }

}

a2gProductsDetail.init();