<?php
defined('TYPO3_MODE') || die();

// PageTS
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig('<INCLUDE_TYPOSCRIPT: source="FILE:EXT:a2g_products/Configuration/TsConfig/Page/All.tsconfig">');

call_user_func(static function() {
    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
        'A2gProducts',
        'A2gproductslist',
        [
            \A2G\A2gProducts\Controller\ProductsController::class => 'list, ajaxList, show'
        ],
        // non-cacheable actions
        [
            \A2G\A2gProducts\Controller\ProductsController::class => ''
        ]
    );

    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
        'A2gProducts',
        'A2gproductsdetail',
        [
            \A2G\A2gProducts\Controller\ProductsController::class => 'show'
        ],
        // non-cacheable actions
        [
            \A2G\A2gProducts\Controller\ProductsController::class => ''
        ]
    );

    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
        'A2gProducts',
        'Ingredientslist',
        [
            \A2G\A2gProducts\Controller\IngredientsController::class => 'list, show'
        ],
        // non-cacheable actions
        [
            \A2G\A2gProducts\Controller\IngredientsController::class => ''
        ]
    );
    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
        'A2gProducts',
        'Ingredientsdetail',
        [
            \A2G\A2gProducts\Controller\IngredientsController::class => 'show'
        ],
        // non-cacheable actions
        [
            \A2G\A2gProducts\Controller\IngredientsController::class => ''
        ]
    );


    // wizards
    /*
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
        'mod {
            wizards.newContentElement.wizardItems.plugins {
                elements {
                    a2gproductslist {
                        iconIdentifier = a2g_products-plugin-a2gproductslist
                        title = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_a2gproductslist.name
                        description = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_a2gproductslist.description
                        tt_content_defValues {
                            CType = list
                            list_type = a2gproducts_a2gproductslist
                        }
                    }
                    a2gproductsdetail {
                        iconIdentifier = a2g_products-plugin-a2gproductsdetail
                        title = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_a2gproductsdetail.name
                        description = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_a2gproductsdetail.description
                        tt_content_defValues {
                            CType = list
                            list_type = a2gproducts_a2gproductsdetail
                        }
                    }
                    ingredientslist {
                        iconIdentifier = a2g_products-plugin-ingredientslist
                        title = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_ingredientslist.name
                        description = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_ingredientslist.description
                        tt_content_defValues {
                            CType = list
                            list_type = a2gproducts_ingredientslist
                        }
                    }
                    ingredientsdetail {
                        iconIdentifier = a2g_products-plugin-ingredientsdetail
                        title = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_ingredientsdetail.name
                        description = LLL:EXT:a2g_products/Resources/Private/Language/locallang_db.xlf:tx_a2g_products_ingredientsdetail.description
                        tt_content_defValues {
                            CType = list
                            list_type = a2gproducts_ingredientsdetail
                        }
                    }
                }
                show = *
            }
       }'
    );
    */

    $iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
    $iconRegistry->registerIcon(
        'a2g_products-plugin-a2gproductslist',
        \TYPO3\CMS\Core\Imaging\IconProvider\BitmapIconProvider::class,
        ['source' => 'EXT:a2g_products/Resources/Public/Icons/online-shopping.png']
    );
    $iconRegistry->registerIcon(
        'a2g_products-plugin-a2gproductsdetail',
        \TYPO3\CMS\Core\Imaging\IconProvider\BitmapIconProvider::class,
        ['source' => 'EXT:a2g_products/Resources/Public/Icons/online-shopping.png']
    );
    $iconRegistry->registerIcon(
        'a2g_products-plugin-ingredientslist',
        \TYPO3\CMS\Core\Imaging\IconProvider\BitmapIconProvider::class,
        ['source' => 'EXT:a2g_products/Resources/Public/Icons/natural-ingredients.png']
    );
    $iconRegistry->registerIcon(
        'a2g_products-plugin-ingredientsdetail',
        \TYPO3\CMS\Core\Imaging\IconProvider\BitmapIconProvider::class,
        ['source' => 'EXT:a2g_products/Resources/Public/Icons/natural-ingredients.png']
    );
});

/***************
 * Register "a2g" as global fluid namespace
 */
$GLOBALS['TYPO3_CONF_VARS']['SYS']['fluid']['namespaces']['a2gprod'][] = 'A2G\\A2gProducts\\ViewHelpers';
